/********************************************************************************
    Copyright (C) 1998/1999 Dirk Farin

    This program is distributed under GNU Public License (GPL) as
    outlined in the COPYING file that comes with the source distribution.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 ********************************************************************************/

#include "arch/MMX/mmx.hh"
#include <assert.h>

bool DidCheckForMMX = false;
bool MMX_Supported;

static class MMX_Check_Dummy_Class
{
public:
  MMX_Check_Dummy_Class()
    {
      int mmx_available;

      __asm__ __volatile__
        (
         /* Get CPU version information */
         "movl $1, %%eax\n\t"
         "cpuid\n\t"
         "andl $0x800000, %%edx\n\t"
         "movl %%edx, %0\n\t"
         : "=q" (mmx_available)
         : /* no input */
         : "%eax","%ebx","%ecx", "%edx"
         );
      MMX_Supported  = mmx_available;
      DidCheckForMMX = true;
    }
} dummy;
