/********************************************************************************
    Copyright (C) 1998/1999 Dirk Farin

    This program is distributed under GNU Public License (GPL) as
    outlined in the COPYING file that comes with the source distribution.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 ********************************************************************************/

#ifndef CODING_BCVIS_HH
#define CODING_BCVIS_HH

#include "coding/bcbase.hh"

class BlockComparator_VIS : public BlockComparator_Base
{
public:
  BlockComparator_VIS() : d_image(NULL) { }
  virtual ~BlockComparator_VIS() { }

  void    SetImageBitmap(const Bitmap<Pixel>& bm,bool frame,bool top);

  bool Error(BCData*,
             const ComparePos&,  // Positionen der 16x16 Bloecke und Half-Pel-Flag
             uint32& error,      // Rueckgabe des Gesamtfehlers.
             uint32  maxerror,   // Obere Grenze fuer den Fehler.
             // Bei Ueberschreitung kann abgebrochen werden.
             int subfact=1       // Unterabtastungsfaktor
             ) const;

private:
  const Pixel*const* d_image;
};

#endif
