/********************************************************************************
    Copyright (C) 1998/1999 Dirk Farin

    This program is distributed under GNU Public License (GPL) as
    outlined in the COPYING file that comes with the source distribution.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 ********************************************************************************/

#ifndef CODING_LOADING_HH
#define CODING_LOADING_HH

#include "control/taskpool.hh"
#include "control/datapool.hh"
#include "image/codedimg.hh"
#include "input/preproc.hh"


/* Laedt ein Bild aus dem 'InputPreprocessor' und transformiert dieses in den
   YUV-Farbraum, bzw. reduziert die Farbaufloesung, wenn es schon im YUV-Farbraum ist.
*/

class Task_Loading : public Task
{
public:
  Task_Loading(class InputPreprocessor& preproc)
    : d_preproc(preproc) { }

  void Execute(ProcessData&);

  // Ergebnis

  int  frame_read;

private:
  class InputPreprocessor& d_preproc;
};


#endif
