/********************************************************************************
    Copyright (C) 1998/1999 Dirk Farin

    This program is distributed under GNU Public License (GPL) as
    outlined in the COPYING file that comes with the source distribution.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 ********************************************************************************/

#ifndef CODING_QUANTSCALE_HH
#define CODING_QUANTSCALE_HH

#include "control/taskpool.hh"
#include "image/codedimg.hh"

class Task_QuantizationScale : public Task
{
public:
  Task_QuantizationScale(int framenr) : m_framenr(framenr) { }

  const int m_framenr;
};


class Task_QuantizationScale_Constant : public Task_QuantizationScale
{
public:
  Task_QuantizationScale_Constant(int framenr)
    : Task_QuantizationScale(framenr), m_qscaletype(0) { }

  void Execute(ProcessData&);

  uint1 m_qscaletype;
};

#endif
