/********************************************************************************
    Copyright (C) 1998/1999 Dirk Farin

    This program is distributed under GNU Public License (GPL) as
    outlined in the COPYING file that comes with the source distribution.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 ********************************************************************************/

#ifndef CODING_RATECONTROL_HH
#define CODING_RATECONTROL_HH

#include "control/taskpool.hh"
// #include "control/datapool.hh"
#include "image/codedimg.hh"
#include "types.hh"

class Task_RateControl : public Task
{
public:
  Task_RateControl(int startframenr,int endframenr)
    : m_startframenr(startframenr),
      m_endframenr(endframenr) { }

  void Execute(ProcessData&);

  const int m_startframenr,m_endframenr;
};

void AssignFrameSizes(int from,int to);
void SetQOffsetToMeetFrameSize(class ImageData*);
void AdjustFramesizePrediction(const class ImageData*);

void AddBufferMismatch(int32 bits); // bits>0 -> Es wurden zu wenig Bits erzeugt.

#endif
