/********************************************************************************
    Copyright (C) 1998/1999 Dirk Farin

    This program is distributed under GNU Public License (GPL) as
    outlined in the COPYING file that comes with the source distribution.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 ********************************************************************************/

#include "coding/utility.hh"
#include <iostream.h>
#include <iomanip.h>

int qcode2qscale[2][32] =
{
//  - 1 2 3 4  5  6  7  8  9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29  30  31
  { 0,2,4,6,8,10,12,14,16,18,20,22,24,26,28,30,32,34,36,38,40,42,44,46,48,50,52,54,56,58, 60, 62 },
  { 0,1,2,3,4, 5, 6, 7, 8,10,12,14,16,18,20,22,24,28,32,36,40,44,48,52,56,64,72,80,88,96,104,112 }
};

int qscale2qcode[2][128];

static class InitClass_QSc2QCode
{
public:
  InitClass_QSc2QCode()
    {
      int i;

      // linear-Skala

      for (i=1;i<=31;i++)
        qscale2qcode[0][2*i-1] = qscale2qcode[0][2*i] = i;
      for (i=63;i<128;i++)
        qscale2qcode[0][i]=31;

      // exp-Skala

      for (i=1;i<=8;i++)
        qscale2qcode[1][i]=i;
      for (i=  9;i<= 10;i++) qscale2qcode[1][i]= 9;
      for (i= 11;i<= 12;i++) qscale2qcode[1][i]=10;
      for (i= 13;i<= 14;i++) qscale2qcode[1][i]=11;
      for (i= 15;i<= 16;i++) qscale2qcode[1][i]=12;
      for (i= 17;i<= 18;i++) qscale2qcode[1][i]=13;
      for (i= 19;i<= 20;i++) qscale2qcode[1][i]=14;
      for (i= 21;i<= 22;i++) qscale2qcode[1][i]=15;
      for (i= 23;i<= 25;i++) qscale2qcode[1][i]=16;
      for (i= 26;i<= 29;i++) qscale2qcode[1][i]=17;
      for (i= 30;i<= 33;i++) qscale2qcode[1][i]=18;
      for (i= 34;i<= 37;i++) qscale2qcode[1][i]=19;
      for (i= 38;i<= 41;i++) qscale2qcode[1][i]=20;
      for (i= 42;i<= 45;i++) qscale2qcode[1][i]=21;
      for (i= 46;i<= 49;i++) qscale2qcode[1][i]=22;
      for (i= 50;i<= 53;i++) qscale2qcode[1][i]=23;
      for (i= 54;i<= 60;i++) qscale2qcode[1][i]=24;
      for (i= 61;i<= 68;i++) qscale2qcode[1][i]=25;
      for (i= 69;i<= 76;i++) qscale2qcode[1][i]=26;
      for (i= 77;i<= 84;i++) qscale2qcode[1][i]=27;
      for (i= 85;i<= 92;i++) qscale2qcode[1][i]=28;
      for (i= 93;i<=100;i++) qscale2qcode[1][i]=29;
      for (i=101;i<=108;i++) qscale2qcode[1][i]=30;
      for (i=109;i<=127;i++) qscale2qcode[1][i]=31;
    }
} dummy;

void ShowDCT(const char* name,DCTBlock& blk)
{
  bool extrem=false;

  for (int v=0;v<8;v++)
    for (int u=0;u<8;u++)
      if (blk.m_coeff[u][v]<-2047)
	extrem=true;

  if (extrem)
    {
      cout << name;
      for (int v=0;v<8;v++,cout << endl)
	for (int u=0;u<8;u++)
	  cout << setw(3) << blk.m_coeff[u][v] << ' ';
    }
}

