/********************************************************************************
    Copyright (C) 1998/1999 Dirk Farin

    This program is distributed under GNU Public License (GPL) as
    outlined in the COPYING file that comes with the source distribution.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 ********************************************************************************/

#ifndef CONTROL_FRAMECODER_HH
#define CONTROL_FRAMECODER_HH

#include "input/preproc.hh"
#include "output/bitstream.hh"
#include "mpeg/syntax.hh"
#include "control/options.hh"

struct FrameData
{
  const Image<Pixel>& m_image;
  uint32              m_bits;

  const Image<Pixel>* m_past_frame;
  const Image<Pixel>* m_future_frame;

  const Image<Pixel>* m_past_top_field;
  const Image<Pixel>* m_past_bottom_field;
  const Image<Pixel>* m_future_top_field;
  const Image<Pixel>* m_future_bottom_field;

  const MVData* m_past_frame_mvdata;
};

class FrameCoder
{
public:
  virtual ~FrameCoder() { }

  virtual void CodeIFrame(const FrameData&) = 0;
  virtual void CodePFrame(const FrameData&) = 0;
  virtual void CodeBFrame(const FrameData&) = 0;

  virtual void CodeIFrame(const FrameData&) = 0;
  virtual void CodePFrame(const FrameData&) = 0;
  virtual void CodeBFrame(const FrameData&) = 0;
};

#endif
