/********************************************************************************
    Copyright (C) 1998/1999 Dirk Farin

    This program is distributed under GNU Public License (GPL) as
    outlined in the COPYING file that comes with the source distribution.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 ********************************************************************************/

#include "control/process.hh"
#include <coding/dct_separated.hh>
#include <coding/dct_coupled.hh>

ProcessData::ProcessData(int thrnr)
  : threadnr(thrnr)
{
  if (1)
    {
      dctcoder_pix     = new DCTCoder_Separated<Pixel>;
      dctcoder_diffpix = new DCTCoder_Separated<DiffPixel>;
    }
  else
    {
#if 0
      dctcoder_pix     = new DCTCoder_Coupled<Pixel>;
      dctcoder_diffpix = new DCTCoder_Coupled<DiffPixel>;
#endif
    }

  dctcoder_pix->SetQScaleType(0);
  dctcoder_pix->SetDCPrecision(8);
  dctcoder_diffpix->SetQScaleType(0);
  dctcoder_diffpix->SetDCPrecision(8);
}

ProcessData::~ProcessData()
{
  if (dctcoder_pix)     delete dctcoder_pix;
  if (dctcoder_diffpix) delete dctcoder_diffpix;
}

