/********************************************************************************
    Copyright (C) 1998/1999 Dirk Farin

    This program is distributed under GNU Public License (GPL) as
    outlined in the COPYING file that comes with the source distribution.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 ********************************************************************************/

#include "control/taskpool.hh"
#include "utility/thread.hh"
#include <iomanip.h>

#if 0

void TaskPool::InsertTask(const Task*)
{
}

const Task* TaskPool::GetTask()
{
#if 0
  uint32 inr=MASK31,pnr=MASK31,bnr=MASK31;

  if (!(d_queue_I.IsEmpty())) inr=d_queue_I.AskHead()->m_frame_nr;
  if (!(d_queue_P.IsEmpty())) pnr=d_queue_P.AskHead()->m_frame_nr;
  if (!(d_queue_B.IsEmpty())) bnr=d_queue_B.AskHead()->m_frame_nr;

  if (inr<pnr && inr<bnr) { const Task* t = d_queue_I.AskHead(); d_queue_I.RemoveHead(); return t; }
  if (pnr<bnr)            { const Task* t = d_queue_I.AskHead(); d_queue_I.RemoveHead(); return t; }
  if (bnr!=MASK31)        { const Task* t = d_queue_I.AskHead(); d_queue_I.RemoveHead(); return t; }
#endif

  if (!d_queue_I.IsEmpty()) { const Task* t = d_queue_I.AskHead(); d_queue_I.RemoveHead(); return t; }
  if (!d_queue_P.IsEmpty()) { const Task* t = d_queue_P.AskHead(); d_queue_P.RemoveHead(); return t; }
  if (!d_queue_B.IsEmpty()) { const Task* t = d_queue_B.AskHead(); d_queue_B.RemoveHead(); return t; }

  return NULL;
}

void TaskPool::TaskCompleted(const Task* t)
{
  Queue<const Task*> newqueue;

  while (!d_under_construction.IsEmpty())
    {
      const Task* first = d_under_construction.AskHead();
      d_under_construction.RemoveHead();
      if (first==t)
        {
          delete t;
          while (!newqueue.IsEmpty())
            {
              d_under_construction.Append(newqueue.AskHead());
              newqueue.RemoveHead();
            }
        }
      else
        {
          newqueue.Append(first);
        }
    }
}

#endif


static Mutex showinfo_mutex;

AutoLock_Output::AutoLock_Output()
{
  showinfo_mutex.Lock();
}

AutoLock_Output::~AutoLock_Output()
{
  showinfo_mutex.Unlock();
}


void ShowTaskInformation(const char* task,int threadnr)
{
  showinfo_mutex.Lock();

  if (threadnr)
    cerr << threadnr << ' ';

  cerr.setf(ios::left,ios::adjustfield);
  cerr << '[' << setw(20) << setfill('.') << task << "] ";
}


void EndShowTaskInformation()
{
  showinfo_mutex.Unlock();
}
