/********************************************************************************
    Copyright (C) 1998/1999 Dirk Farin

    This program is distributed under GNU Public License (GPL) as
    outlined in the COPYING file that comes with the source distribution.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 ********************************************************************************/

#ifndef CONTROL_TASKSEQHDR_HH
#define CONTROL_TASKSEQHDR_HH

#include "control/taskpool.hh"
#include "image/codedimg.hh"

class Task_InsertSeqHdr : public Task
{
public:
  Task_InsertSeqHdr(int framenr,class InputPreprocessor& preproc)
    : m_preproc(preproc), m_framenr(framenr) { }

  void Execute(ProcessData&);

  const class InputPreprocessor& m_preproc;
  const int m_framenr;
};


class Task_DeleteSeqHdr : public Task
{
public:
  Task_DeleteSeqHdr(int framenr) : m_framenr(framenr) { }

  void Execute(ProcessData&);

  const int m_framenr;
};

#endif
