/********************************************************************************
    Copyright (C) 1998/1999 Dirk Farin

    This program is distributed under GNU Public License (GPL) as
    outlined in the COPYING file that comes with the source distribution.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 ********************************************************************************/

#ifndef INPUT_PREPROC_MIRO_AVI_HH
#define INPUT_PREPROC_MIRO_AVI_HH

#ifndef DISABLE_MJPEG
#define DISABLE_MJPEG 0
#endif

#if !DISABLE_MJPEG

#include "input/preproc.hh"
#include "types.hh"

extern "C" {
#include <stdio.h>
#include <jpeglib.h>
}


class InputPreprocessor_MiroAVI : public InputPreprocessor
{
public:
  InputPreprocessor_MiroAVI();
  ~InputPreprocessor_MiroAVI();

  // Initialisierungsroutinen sind in dieser Reihenfolge anzuwenden !
  void SetInputFile(const char* filename,bool interlaced=false);
  void SetFrameRange(uint32 firstframe,uint32 lastframe);
  void SetSmallMode();
  void Init();

  bool         IsProgressiveSequence() const;
  bool         HasMoreInput() const;
  int          AskNextImageNum() const;
  const char*  AskNextImageFilename() const;
  class Image<Pixel>* GetNextImage(class Image<Pixel>* reuse);
  int          AskFramerate100() const;

  int          AskWidth() const  { return d_width;  }
  int          AskHeight() const { return d_height; }

private:
  struct jpeg_decompress_struct cinfo;
  struct jpeg_error_mgr jerr;
  FILE* infile;

  uint32 d_FirstFrame,d_LastFrame;
  bool   d_smallmode;
  uint32 nPicsInStream;
  uint32 piccnt;

  Image<Pixel>* d_nextimg;
  int d_width,d_height;
};

#endif

#endif
