/********************************************************************************
    Copyright (C) 1998/1999 Dirk Farin

    This program is distributed under GNU Public License (GPL) as
    outlined in the COPYING file that comes with the source distribution.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 ********************************************************************************/

#ifndef INPUT_REMOTE_HH
#define INPUT_REMOTE_HH

#include "types.hh"
#include <sys/time.h>

class Remote
{
public:
  virtual ~Remote() { }

  virtual bool EndOfStream() const { return false; }
  virtual void NextPicture() = 0;
  virtual void WaitForNextPicture() const = 0;
};


enum IRCode { Panasonic_FS1 , Samsung_SV300W, Pioneer_CLD950 , Sony_VCR , IRCode_Invalid };


class Remote_IR : public Remote
{
public:
  Remote_IR(enum IRCode);
  ~Remote_IR();

  void NextPicture();
  void WaitForNextPicture() const;

private:
  void SendPulse(int onoff) const;
  void Send(const char*) const;

  int d_fd_ser;
  const char* d_start;
  const char* d_step;
  const char* d_end;
  int d_waittime;

  struct timeval d_sendtv;
};

#endif
