/********************************************************************************
    Copyright (C) 1998/1999 Dirk Farin

    This program is distributed under GNU Public License (GPL) as
    outlined in the COPYING file that comes with the source distribution.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 ********************************************************************************/
/*
  1-D DCT nach Arai, Agui, Nakajima.

  13 Multiplikationen und 29 Additionen.
  Der Vorteil dieses Algorithmus ist, dass 8 Multiplikationen um Ende
  ausgefuehrt werden und somit in diesem Schritt auch die Quantisierung
  erfolgen kann, was 8 Multiplikationen spart.
 */

#ifndef MATH_DCT1_ARAI_HH
#define MATH_DCT1_ARAI_HH

#include "types.hh"
#include "math/dct.hh"


class DCT1_AraiAguiNakajima : public FDCT1, public IDCT1
{
public:
   DCT1_AraiAguiNakajima();
  ~DCT1_AraiAguiNakajima() { }

  void SetOutputScalefactors(DCTFloat fact[8]);
  void RemoveOutputScalefactors();

  void PerformFDCT1(const DCTFloat in[8],DCTFloat out[8]);
  void PerformIDCT1(const DCTFloat in[8],DCTFloat out[8]);

private:
  DCTFloat d_output_factors[8];
  DCTFloat d_output_factors_INV[8];
};

#endif
