/********************************************************************************
    Copyright (C) 1998/1999 Dirk Farin

    This program is distributed under GNU Public License (GPL) as
    outlined in the COPYING file that comes with the source distribution.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 ********************************************************************************/
/*
  Berechnet DCT-2 durch Separierung in 16 DCT-1 Arai,Agui,Nakajima Transformationen.
 */

#ifndef MATH_DCT2_ARAI
#define MATH_DCT2_ARAI

#include "math/dct.hh"

class DCT2_AraiAguiNakajima : public FDCT2
{
public:
   DCT2_AraiAguiNakajima();
  ~DCT2_AraiAguiNakajima() { }

  void SetOutputScalefactors(const DCTFloat* fact[8]);
  void RemoveOutputScalefactors();

  void PerformFDCT2(const short* in[8] /* [y][x] */, DCTBlock& out);
  void PerformFDCT2(const uint8* in[8] /* [y][x] */, DCTBlock& out) { FDCT2::PerformFDCT2(in,out); }

private:
  DCTFloat d_fact[8][8];
};


class IDCT2_AraiAguiNakajima : public IDCT2
{
public:
   IDCT2_AraiAguiNakajima();
  ~IDCT2_AraiAguiNakajima() { }

  void SetOutputScalefactors(const DCTFloat* fact[8]);
  void RemoveOutputScalefactors();

  void PerformIDCT2(const short* in[8], uint8* out[8],bool add);

private:
  DCTFloat d_fact[8][8];
};

#endif
