/********************************************************************************
    Copyright (C) 1998/1999 Dirk Farin

    This program is distributed under GNU Public License (GPL) as
    outlined in the COPYING file that comes with the source distribution.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 ********************************************************************************/

#include "math/dct2_separated.hh"
#include <math.h>


#include <iostream.h>
#include <iomanip.h>

void DCT2_Separated::SetDCT1s(DCT1* onedim_dct[9])
{
  for (int i=0;i<9;i++)
    d_dct1[i] = onedim_dct[i];
}

void DCT2_Separated::SetOutputScalefactors(DCTFloat* fact[8])
{
  for (int i=0;i<8;i++)
    d_dct1[i]->SetOutputScalefactors(fact[i]);
}

void DCT2_Separated::RemoveOutputScalefactors()
{
  for (int i=0;i<8;i++)
    d_dct1[i]->RemoveOutputScalefactors();
}

void DCT2_Separated::PerformFDCT2(const short* in[8],short* out[8])
{
  DCTFloat tmpcolin[8];
  DCTFloat tmpcolout[8];
  DCTFloat tmp[8][8];

  for (int x=0;x<8;x++)
    {
      for (int y=0;y<8;y++)
	tmpcolin[y]=in[y][x];

      d_dct1[8]->PerformFDCT1(tmpcolin,tmpcolout);

      for (int y=0;y<8;y++)
	tmp[y][x]=tmpcolout[y];
    }

  DCTFloat tmp2[8][8];

  for (int y=0;y<8;y++)
    d_dct1[y]->PerformFDCT1(tmp[y],tmp2[y]);

  for (int x=0;x<8;x++)
    for (int y=0;y<8;y++)
      out[y][x]=(int)(tmp2[y][x]+0.499999);
}

void DCT2_Separated::PerformIDCT2(const short* in[8],short* out[8])
{
  DCTFloat tmp[8][8];
  for (int x=0;x<8;x++)
    for (int y=0;y<8;y++)
      tmp[y][x]=in[y][x];

  DCTFloat tmp2[8][8];
  for (int y=0;y<8;y++)
    d_dct1[y]->PerformIDCT1(tmp[y],tmp2[y]);

  DCTFloat tmpcolin[8];
  DCTFloat tmpcolout[8];
  for (int x=0;x<8;x++)
    {
      for (int y=0;y<8;y++)
	tmpcolin[y]=tmp2[y][x];

      d_dct1[8]->PerformIDCT1(tmpcolin,tmpcolout);

      for (int y=0;y<8;y++)
	out[y][x]=(int)floor(tmpcolout[y]+0.5);
    }
}
