/********************************************************************************
    Copyright (C) 1998/1999 Dirk Farin

    This program is distributed under GNU Public License (GPL) as
    outlined in the COPYING file that comes with the source distribution.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 ********************************************************************************/
/*
  Berechnet DCT-2 durch Separierung in 16 DCT-1 Transformationen.
 */

#ifndef MATH_DCT2_SEPARATED
#define MATH_DCT2_SEPARATED

#include "math/dct.hh"

class DCT2_Separated : public FDCT2, public IDCT2
{
public:
   DCT2_Separated() { }
   DCT2_Separated(DCT1* onedim_dct[9]) { SetDCT1s(onedim_dct); }
  ~DCT2_Separated() { }
  void SetDCT1s(DCT1* onedim_dct[9]);

  void SetOutputScalefactors(const DCTFloat* fact[8]);
  void RemoveOutputScalefactors();

  void PerformFDCT2(const short* in[8],short* out[8]);
  void PerformIDCT2(const short* in[8],short* out[8]);

private:
  DCT1* d_dct1[9];
};

#endif
