/********************************************************************************
    Copyright (C) 1998/1999 Dirk Farin

    This program is distributed under GNU Public License (GPL) as
    outlined in the COPYING file that comes with the source distribution.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 ********************************************************************************/

#ifndef MPEG_SYNTAX_HH
#define MPEG_SYNTAX_HH

#include "output/bitbuffer.hh"
// #include "control/options.hh"
#include "image/codedimg.hh"
#include "mpeg/syntaxelems.hh"
#include "control/datapool.hh"

class MPEGSyntaxCoder
{
public:
  MPEGSyntaxCoder(BitBuffer& bs/*,const EncodingOptions& opts*/) : /*d_encopts(opts),*/ d_bs(&bs) { }
  ~MPEGSyntaxCoder() { }

  void SetOutput(BitBuffer& bs) { d_bs = &bs; }

  void SetSequenceHeader(const SequenceHeaderData& sh) { d_seqhdr = sh; }

  void WriteSequenceHeader();
  void WriteGOPHeader(const GOPHeaderData&);
  void WritePicture(ImageData&);

private:
  //const EncodingOptions& d_encopts;
  BitBuffer*             d_bs;
  SequenceHeaderData     d_seqhdr;

  void WritePictureHeader(const PictureHeaderData&);
  void WriteSliceHeader(const SliceHeaderData&);
  void CodeBlock(const DCTBlock& blk,bool mbintra,bool isY,short& pred,bool alternatescan,bool UseB15);
  void motion_vectors(const PictureHeaderData&,const Macroblock&,int direction);
  void motion_vector (const PictureHeaderData&,const Macroblock&,int n,int direction);

  // --- Daten, die jeweils fuer das gerade zu codierende Bild zwischengespeichert werden ---

  int d_f[2][2],d_range[2][2];  // [s][t]
  int d_PMV[2][2][2]; // [r][s][t]

  void ResetPMV();
};

int BitsToCodeCoeff(const Macroblock& mb,const PictureHeaderData&);

#endif
