/********************************************************************************
    Copyright (C) 1998/1999 Dirk Farin

    This program is distributed under GNU Public License (GPL) as
    outlined in the COPYING file that comes with the source distribution.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 ********************************************************************************/

#ifndef OUTPUT_BITSTREAM_HH
#define OUTPUT_BITSTREAM_HH

#include "types.hh"
#include "output/streamsink.hh"

const int BufferLength = 1000;

class OutputBitstream
{
public:
   OutputBitstream(StreamSink& sink);
  ~OutputBitstream() { Flush(); }

  void WriteBits(BitArray bits,int nBits); // Bits sind rechtsbuendig drin.
  void WriteBitsMasked(BitArray bits,int nBits);
  void WriteBits(BitArray bits,int nBits,int firstbit); // Bits sind um 'firstbit' nach links verschoben.
  void FillByte(); // Auf die naechste Bytegrenze mit 0 auffuellen. Nichts machen, wenn schon an Grenze.
  void Flush();    // Alle gepufferten Daten abspeichern.
                   // Dabei wird ggf. angefangenes Byte mit 0 aufgefuellt.

private:
  StreamSink& d_streamsink;
  BitArray    d_buffer[BufferLength];
  int         d_bufferidx;
  int         d_freebits;

  void Clear();
  void WriteBuffer(); // Alle komplett gefuellten Eintraege des Buffer abspeichern. Danach
                      // Wird ein evtl. erst teilweise gefuellter Eintrag nach d_buffer[0] verschoben.
};

#endif
